% ECLiPSe wrapper module for press-src/lpdir/lp.pl

:- module(lp, [solve/1,solve/3], quintus).

:- get_flag(library_path, P),
   get_flag(cwd,D), concat_string([D,'press-src/lpdir'],LPD),
   set_flag(library_path, [LPD|P]).

:- local append/3, ground/1.

% Catch and handle some of the unix/1 calls made by the original code,
% in order to avoid Unix dependencies.
:- local unix/1.
unix(system('echo -n ''v_d("'' > $HOME/d.tmp;date >> $HOME/d.tmp;echo ''").'' >> $HOME/d.tmp')) :- !,
	open('$HOME/d.tmp',write,Stream),
	write(Stream,'v_d("today.").'), nl(Stream),
	close(Stream).
unix(system('rm $HOME/d.tmp')) :- !,
	delete('$HOME/d.tmp').
unix(system(date)) :- !,
	%get_flag(unix_time,T), local_time_string(T,'%c', D), write(D), nl.
	write(date), nl.
unix(C) :-
	write(ignoring:unix(C)), nl.
	
% Optional: Make statistics(runtime,_) return zeros, to have reproduceable output
:- local statistics/2.
statistics(runtime, R) :- !, R=[0,0].
statistics(Name, Value) :- quintus:statistics(Name, Value).

% suppress undefined-warning
give_help(dummy).


% should be discontiguous, but that must be in the corresponding file...
:- dynamic(show/1).		% out.pl
:- dynamic(obtain_rule1/5).	% conj.pl
:- dynamic(remove/1).		% flag.pl
:- dynamic(nasty_act/5).	% nasty.pl
:- dynamic(poly_method/4).	% nasty.pl
:- dynamic(anaz/5).		% homog.pl

% Dynamic (to avoid warning)
:- dynamic(just_created/1).

:- [library(lp)].   % load the original code
